package rip.iwakura.civilcore;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockBurnEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.block.BlockSpreadEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.entity.EntityDamageEvent.DamageCause;
import org.bukkit.event.player.PlayerBucketEmptyEvent;

public class Court implements Listener,CommandExecutor{
  private World court_world = Bukkit.getWorld("court");

  private Location court_location = new Location(court_world, 4.5, 70.0, 0.5, -90f, 1.0f);

  @EventHandler
  public void PlayerPlaceWater(PlayerBucketEmptyEvent e) {
    Player p = (Player) e.getPlayer();
    if (!p.getLocation().getWorld().getName().equals("court")) return;
    e.setCancelled(true);
  }

  @EventHandler
  public void PlayerHurt(EntityDamageEvent e) {
    if (!(e.getEntity() instanceof Player)) return;
    Player p = (Player) e.getEntity();

    if (!p.getLocation().getWorld().getName().equals("court")) return;

    e.setCancelled(true);

    if (e.getCause() == DamageCause.VOID) {
      p.teleport(court_location);
      return;
    }
  }

  @EventHandler
  public void PlayerBreak(BlockBreakEvent e) {
    if (e.getPlayer().isOp()) return;
    if (e.getBlock().getWorld().getName().equals(court_world.getName())) e.setCancelled(true);
  }
  @EventHandler
  public void PlayerPlace(BlockPlaceEvent e) {
    if (e.getPlayer().isOp()) return;
    if (e.getBlock().getWorld().getName().equals(court_world.getName())) e.setCancelled(true);
  }
  @EventHandler
  public void PlayerBurn(BlockBurnEvent e) {
    if (e.getBlock().getWorld().getName().equals(court_world.getName())) e.setCancelled(true);
  }
  @EventHandler
  public void FireSpread(BlockSpreadEvent e) {
    if (e.getBlock().getWorld().getName().equals(court_world.getName())) e.setCancelled(true);
  }
  @Override
  public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
    if (!(sender instanceof Player)) {
      sender.sendMessage("Non-player type.");
      return true;
    }

    Player p = (Player) sender;

    switch (args[0]) {
      case "enter":
        p.teleport(court_location);
        break;
      case "leave":
        Location loc = p.getBedSpawnLocation();
        if (loc == null) {
          loc = Bukkit.getWorld("world").getSpawnLocation();
        }
        p.teleport(loc);
        break;
    }
    return true;
  }

}
