package rip.iwakura.civilcore.commands;

import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import net.md_5.bungee.api.ChatColor;
import org.jetbrains.annotations.NotNull;
import rip.iwakura.civilcore.Utils;
import rip.iwakura.civilcore.CivilCore;

import java.util.Objects;

public class TeamChatCommand implements CommandExecutor {
  private final CivilCore civilCore;

  public TeamChatCommand(CivilCore civilCore) {
    this.civilCore = civilCore;
  }

  @Override
  public boolean onCommand(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, String[] args) {
    args = Objects.requireNonNull(Utils.parser(args)).toArray(new String[0]);

    if (!(sender instanceof Player p)) return true;
    if (args.length == 0) {
      if (civilCore.teamChatRegister.contains(p)) {
        civilCore.teamChatRegister.remove(p);
        p.sendMessage(ChatColor.GREEN + "You are now in the " + ChatColor.GOLD + "GLOBAL" + ChatColor.GREEN + " channel");
      } else {
        civilCore.teamChatRegister.add(p);
        p.sendMessage(ChatColor.GREEN + "You are now in the " + ChatColor.GOLD + "TEAM" + ChatColor.GREEN + " channel");
      }
        return true;
    }

    String message = String.join(" ", args);
    if (civilCore.teamChatRegister.contains(p)) {
      civilCore.teamChatRegister.remove(p);
      Bukkit.broadcastMessage(ChatColor.DARK_GREEN + "TEAM > " + ChatColor.GREEN + p.getName() + ": " + message);
      civilCore.teamChatRegister.add(p);
    } else {
      civilCore.teamChatRegister.add(p);
      Bukkit.broadcastMessage(p.getName() + ": " + message);
      civilCore.teamChatRegister.remove(p);
    }



    return true;
  }
}
